import {
  select,
  csvParse,
  min,
  max,
  extent,
  sum,
  group,
  rollup,
  flatGroup,
  flatRollup,
  bin,
  flatBin,
} from 'd3';

export const viz = (container, options) => {
  const [state, setState] = options;
  const { data } = state;

  if (data && data !== 'LOADING') {
    // Set & Map
    // const speciesSet = new Set(data.map(d => d.species))
    // console.log(speciesSet);

    // MIN, MAX & EXTENT
    // console.log(min(data, (d) => d.petal_length));
    // console.log(max(data.map((d) => d.petal_length)));
    // console.log(extent(data.map(d => d.petal_length)));

    // GROUP, ROLLUP, BIN
    // console.log(Array.from(group(data, (d) => d.species)));
    // console.log(group(data, (d) => d.species));
    // console.log(flatGroup(data, (d) => d.species));
    // console.log(rollup(
    //   data,
    //   (v) => sum(v, d => d.sepal_length) / v.length,
    //   (d) => d.species
    // ));
    // console.log(flatRollup(
    //   data,
    //   (v) => sum(v, d => d.sepal_length) / v.length,
    //   (d) => d.species
    // ).map(([species, avg]) => ({
    //   species,
    //   avarageSepalLength: avg,
    // })));

    console.log(
      bin()(
        data.map((d) => d.sepal_length)
      ).map((v) => ({
        x0: v.x0,
        x1: v.x1,
        count: v.length,
      })) 
    );
  }

  select(container)
    .selectAll('pre')
    .data([null])
    .join('pre')
    .text(JSON.stringify(data, null, 2));

  if (!data) {
    setState((prev) => ({ ...prev, data: 'LOADING' }));

    fetch('data.csv')
      .then((res) => res.text())
      .then((csvString) => {
        const data = csvParse(csvString);

        data.forEach((d) => {
          (d.sepal_length = +d.sepal_length),
            (d.sepal_width = +d.sepal_width),
            (d.petal_width = +d.petal_width),
            (d.petal_length = +d.petal_length);
        });

        setState((prev) => ({ ...prev, data: data }));
      });
  }
};
